import ".";
inherit Event;

// ----------------------------------------------------------------
// special nameday objects
// ----------------------------------------------------------------

class Sweden
{
   inherit Namedays;

   mapping lookup_pre1986=0;
   mapping lookup_1986=0;
   mapping lookup_1993=0;

   void create()
   {
      name="Sweden";
   }

   static array(string) namedays_year(int y)
   {
      if (y<1986) return swedish_namedays_pre1986;
      if (y<1993) return swedish_namedays_1986;
      return swedish_namedays_1993;
   }

   static int nameday_lookup(int y,string s)
   {
      if (y<1986) 
	 return (lookup_pre1986||
		 (lookup_pre1986=make_lookup(swedish_namedays_pre1986)))
	    [lower_case(s)];
      if (y<1993) 
	 return (lookup_1986||
		 (lookup_1986=make_lookup(swedish_namedays_1986)))
	    [lower_case(s)];
      return (lookup_1993||
	      (lookup_1993=make_lookup(swedish_namedays_1993)))
	 [lower_case(s)];
   }

   constant swedish_namedays_pre1986=
   ({ 0, "Svea", "Alfred", "Rut", "Hanna", 0 /* trettondag */,
      "August", "Erland", "Gunnar", "Sigurd", "Hugo", "Frideborg",
      "Knut", "Felix", "Laura", "Hjalmar", "Anton", "Hilda", "Henrik",
      "Fabian", "Agnes", "Vincent", "Emilia", "Erika", "Paulus",
      "Botolda", "Gte", "Karl", "Valter", "Gunhild", "Ivar", "Max",
      0/*kyndels*/, "Disa", "Ansgar", "Agata", "Dorotea", "Rikard",
      "Berta", "Fanny", "Eugenia", "Yngve", "Evelina", "Agne",
      "Valentin", "Sigfrid", "Julia", "Alexandra", "Frida",
      "Gabriella", "Hulda", "Hilding", "Martina", "Torsten",
      "Mattias", "Sigvard", "Torgny", "Lage", "Maria", "Albin",
      "Ernst", "Gunborg", "Adrian", "Tora", "Ebba", "Ottilia",
      "Filippa", "Torbjrn", "Edla", "Edvin", "Viktoria", "Greger",
      "Matilda", "Kristofer", "Herbert", "Gertrud", "Edvard", "Josef",
      "Joakim", "Bengt", "Viktor", "Gerda", "Gabriel", "Mary",
      "Emanuel", "Rudolf", "Malkolm", "Jonas", "Holger", "Ester",
      "Harald", "Gudmund", "Ferdinand", "Ambrosius", "Nanna",
      "Vilhelm", "Ingemund", "Hemming", "Otto", "Ingvar", "Ulf",
      "Julius", "Artur", "Tiburtius", "Olivia", "Patrik", "Elias",
      "Valdemar", "Olavus Petri", "Amalia", "Anselm", "Albertina",
      "Georg", "Vega", "Markus", "Teresia", "Engelbrekt", "Ture",
      "Tyko", "Mariana", "Valborg", "Filip", "Gta", "Monika",
      "Gotthard", "Sigmund", "Gustava", "ke", "Jonathan", "Esbjrn",
      "Mrta", "Charlotta", "Linnea", "Halvard", "Sofia", "Hilma",
      "Rebecka", "Erik", "Alrik", "Karolina", "Konstantin", "Henning",
      "Desideria", "Ragnvald", "Urban", "Vilhelmina", "Blenda",
      "Ingeborg", "Baltsar", "Fritjof", "Isabella", "Nikodemus",
      "Rutger", "Ingemar", "Holmfrid", "Bo", "Gustav", "Robert",
      "Salomon", "Brje", "Svante", "Bertil", "Eskil", "Aina",
      "Hkan", "Justina", "Axel", "Torborg", "Bjrn", "Germund",
      "Flora", "Alf", "Paulina", "Adolf", "Johan", "David", "Rakel",
      "Selma", "Leo", "Petrus", "Elof", "Aron", "Rosa", "Aurora",
      "Ulrika", "Melker", "Esaias", "Klas", "Kjell", "Gtilda",
      "Anund", "Eleonora", "Herman", "Joel", "Folke", "Ragnhild",
      "Reinhold", "Alexis", "Fredrik", "Sara", "Margareta", "Johanna",
      "Magdalena", "Emma", "Kristina", "Jakob", "Jesper", "Marta",
      "Botvid", "Olof", "Algot", "Elin", "Per", "Karin", "Tage",
      "Arne", "Ulrik", "Sixten", "Arnold", "Sylvia", "Roland", "Lars",
      "Susanna", "Klara", "Hillevi", "Ebbe", "Stella", "Brynolf",
      "Verner", "Helena", "Magnus", "Bernhard", "Josefina",
      "Henrietta", "Signe", "Bartolomeus", "Lovisa", "sten", "Rolf",
      "Augustin", "Hans", "Albert", "Arvid", "Samuel", "Justus",
      "Alfhild", "Moses", "Adela", "Sakarias", "Regina", "Alma",
      "Augusta", "Tord", "Dagny", "Tyra", "Ambjrn", "Ida", "Sigrid",
      "Eufemia", "Hildegard", "Alvar", "Fredrika", "Agda", "Matteus",
      "Maurits", "Tekla", "Gerhard", "Signhild", "Enar", "Dagmar",
      "Lennart", "Mikael", "Helge", "r", "Ludvig", "Evald", "Frans",
      "Bror", "Jenny", "Birgitta", "Nils", "Ingrid", "Helmer",
      "Erling", "Valfrid", "Teofil", "Manfred", "Hedvig", "Fingal",
      "Antonietta", "Lukas", "Tore", "Sibylla", "Birger", "Seved",
      "Sren", "Evert", "Inga", "Amanda", "Sabina", "Simon", "Viola",
      "Elsa", "Edit", 0 /* allhelgona */, "Tobias", "Hubert",
      "Sverker", "Eugen", "Gustav Adolf", "Ingegerd", "Vendela",
      "Teodor", "Martin Luther", "Mrten", "Konrad", "Kristian",
      "Emil", "Leopold", "Edmund", "Napoleon", "Magnhild", "Elisabet",
      "Pontus", "Helga", "Cecilia", "Klemens", "Gudrun", "Katarina",
      "Torkel", "Astrid", "Malte", "Sune", "Anders", "Oskar", "Beata",
      "Lydia", "Barbro", "Sven", "Nikolaus", "Agaton", "Virginia",
      "Anna", "Malin", "Daniel", "Alexander", "Lucia", "Sten",
      "Gottfrid", "Assar", "Inge", "Abraham", "Isak", "Israel",
      "Tomas", "Natanael", "Adam", "Eva", "Stefan", "Johannes",
      "Abel", "Set", "Sylvester",0});

   constant swedish_namedays_1986=
   ({ 0, "Svea,Bore,Sverre",
      "Alfred,Alfrida,Annefrid", "Rut,Ritva,Roger",
      "Hanna,Hannele,Hanny", 0 /* trettondag */, "August,jar,rjan",
      "Erland,Erhard,Erla", "Gunnar,Gun,Gunno", "Sigurd,Sigrun,Sigyn",
      "Hugo,Hagar", "Frideborg,Fridolf,Fridolin", "Knut,Kent,Kennet",
      "Felix,Felicia,Fritz", "Laura,Lauritz,Lotten",
      "Hjalmar,Herdis,Hjrdis", "Anton,Anja,Antonia",
      "Hilda,Hildor,Hildur", "Henrik,Henrika,Henry", "Fabian,Lina,Linus",
      "Agnes,Agnar,Agneta", "Vincent,Vanja,Veine",
      "Emilia,Emilie,Mildred", "Erika,Jarl,Jarla", "Paulus,Paul,Paula",
      "Botolda,Tilda,Tilly", "Gte,Gtar,Jns", "Karl,Kally,Karla",
      "Valter,Valerie,Volter", "Gunhild,Gunilla,Gunnel", "Ivar,Iva,Ivan",
      "Max,Marielle,Marietta", 0/*kyndels*/, "Disa,Dick,Didrik",
      "Ansgar,Anneli,Ansa", "Agata,Aili,Aivi", "Dorotea,Dora,Doris",
      "Rikard,Ricky,Rigmor", "Berta,Bert,Bertram", "Fanny,Sanny,Sonny",
      "Eugenia,Egon,Eira", "Yngve,Yvette,Yvonne",
      "Evelina,Elaine,Evelyn", "Agne,Alin,Alina",
      "Valentin,Valentina,Vally", "Sigfrid,Sigbert,Sigbritt",
      "Julia,Juliana,Juliette", "Alexandra,Sandor,Sandra",
      "Frida,Fride,Frode", "Gabriella,Ella,Elna", "Hulda,Haldis,Haldo",
      "Hilding,Hildeborg,Hildemar", "Martina,Tim,Tina",
      "Torsten,Toivo,Torun", "Mattias,Matti,Mats",
      "Sigvard,Sigvald,Sigvor", "Torgny,Torvald", "Lage,Laila,Lave",
      "Maria,Marie,Mary", "Albin,Alba,Alban", "Ernst,Erna,Ernfrid",
      "Gunborg,Gunbritt,Gunvald", "Adrian,Adrienne,Astor",
      "Tora,Toini,Tor", "Ebba,Ebon,Evonne", "Ottilia,Petra,Petronella",
      "Filippa,Gunlg,slg", "Torbjrn,Torben,Torgun",
      "Edla,Edling,Ethel", "Edvin,Diana,Edna", "Viktoria,Vibeke,Viking",
      "Greger,Grels,Greta", "Matilda,Maud,Moa",
      "Kristofer,Christel,Christer", "Herbert,Herta,Hervor",
      "Gertrud,Gertie,Glin", "Edvard,Eda,Eddie", "Josef,James,Janet",
      "Joakim,Jockum,Kim", "Bengt,Bengta,Benita", "Viktor,Vimar,Vge",
      "Gerda,Anngerd,Gerd", "Gabriel,Gabrielle,Gunni", "Mary,Marion",
      "Emanuel,Emanuella,Immanuel", "Rudolf,Rode,Rudi",
      "Malkolm,Elma,Elmer", "Jonas,Jon,Jonna", "Holger,Olga",
      "Ester,Estrid,Vasti", "Harald,Hadar,Hardy",
      "Gudmund,Gudmar,Gunder", "Ferdinand,Gunvi,Gunvor",
      "Ambrosius,Irene,Irina", "Nanna,Nancy,Nanny",
      "Vilhelm,William,Willy", "Ingemund,Ingemo,Irma",
      "Hemming,Heimer,Helmut", "Otto,Orvar,Ottar",
      "Ingvar,Ingvald,Ingvor", "Ulf,Ylva,Yrsa", "Julius,Gillis",
      "Artur,Aldor,Atle", "Tiburtius,Ellen,Elly", "Olivia,Oliver,Ove",
      "Patrik,Patricia,Percy", "Elias,Elis,Elise",
      "Valdemar,Valdis,Volmar", "Olavus Petri,Olaus Petri",
      "Amalia,Amelie,Amy", "Anselm,Annevi,Annvor",
      "Albertina,Alida,Allan", "Georg,Georgina,Jrgen",
      "Vega,Viggo,Viveka", "Markus,Marika,Mark", "Teresia,Terese,Tessy",
      "Engelbrekt,Engelbert,Enok", "Ture,Turid,Tuve",
      "Tyko,Toralf,Torulf", "Mariana,Marianne,Marina",
      "Valborg,Maj,Maja", "Filip,sa,se", "Gta,Grel,Gtmar",
      "Monika,Majne,Mona", "Gotthard,Gotthild,Gotty", "Sigmund,Sigge",
      "Gustava,Gullvi,Gullbritt", "ke,ge,got", "Jonathan,John,Johnny",
      "Esbjrn,Elvy,Essy", "Mrta,Meta,Mrit",
      "Charlotta,Charlotte,Lotta", "Linnea,Linn,Lis",
      "Halvard,Hallvor,Halvar", "Sofia,Sia,Sofie", "Hilma,Helvi,Hilmer",
      "Rebecka,Renee,Rosita", "Erik,Erk,Jerker", "Alrik,Alda,Altea",
      "Karolina,Carola,Caroline", "Konstantin,Conny,Konstatia",
      "Henning,Henny,Pl", "Desideria,Dennis,Desiree",
      "Ragnvald,Ragnvi,Ragnvor", "Urban,Una,Uno",
      "Vilhelmina,Vilma,Vilmar", "Blenda,Beda,Britten",
      "Ingeborg,Ingabritt,Ingbritt", "Baltsar,Bill,Billy",
      "Fritjof,Majny,Majvi", "Isabella,Iris,Isa", "Nikodemus,Nina,Ninni",
      "Rutger,Runa,Rune", "Ingemar,Ingar,Ingmarie",
      "Holmfrid,Helfrid,Helfrida", "Bo,Bodil,Boel",
      "Gustav,Gusten,Gsta", "Robert,Robin,Ruben", "Salomon,Sally",
      "Brje,Belinda,Bjrg", "Svante,Sante,Sjunne",
      "Bertil,Berit,Berthold", "Eskil,Eje,Evan", "Aina,Aino,Roine",
      "Hkan,Hakon,Hakvin", "Justina,Jim,Jimmy", "Axel,Axelia,Axelina",
      "Torborg,Torhild,Toril", "Bjrn,Bjarne,Bjrne",
      "Germund,Jerry,Jill", "Flora,Florence,Florentin",
      "Alf,Alvin,Alvina", "Paulina,Pamela,Paulette",
      "Adolf,Adolfina,Ally", "Johan,Jan", "David,Davida,Daisy",
      "Rakel,Rafael,Ralf", "Selma,Selim,Selmer", "Leo,Lola,Liselott",
      "Petrus,Peter,Petter", "Elof,Elvira,Viran", "Aron,Arent,Arild",
      "Rosa,Rose,Rosemarie", "Aurora,Andre,Aurelia",
      "Ulrika,Ellika,Ulla", "Melker,Marja,Mirjam", "Esaias,Elisiv,Esse",
      "Klas,Claudia,Klaus", "Kjell,Kajsa,Kettil", "Gtilda,Gran,Jrn",
      "Anund,Anita,Ante", "Eleonora,Eleonor,Ellinor",
      "Herman,Hanne,Hermine", "Joel,Joar,Jorunn", "Folke,Fale,Fylgia",
      "Ragnhild,Ragni,Runo", "Reinhold,Reine,Reino", "Alexis,Alex,Alice",
      "Fredrik,Fred,Freddy", "Sara,Charles,Saga",
      "Margareta,Margit,Margret", "Johanna,Jean,Jeanette",
      "Magdalena,Magda,Madeleine", "Emma,Elena,Emmy",
      "Kristina,Kerstin,Kristin", "Jakob,Jack", "Jesper,Jessika,Jessie",
      "Marta,Marit,Marita", "Botvid,Reidar,Reidun", "Olof,Ola,Olle",
      "Algot,Margot,Vilgot", "Elin,Elon,Elina", "Per,Peder,Pernilla",
      "Karin,Karen,Kre", "Tage,Tanja,Truls", "Arne,Arna,Arnevi",
      "Ulrik,Unn,Unni", "Sixten,Sve,Slve", "Arnold,Annika,Annmari",
      "Sylvia,Silja,Silvia", "Roland,Ronald,Ronny", "Lars,Lasse,Lorentz",
      "Susanna,Sanna,Susanne", "Klara,Clarence,Clary",
      "Hillevi,Hilja,Irja", "Ebbe,Eberhard,Efraim",
      "Stella,Estelle,Stellan", "Brynolf,Benjamin,Benny",
      "Verner,Verna,Veronika", "Helena,Helen,Helny",
      "Magnus,Mogens,Mns", "Bernhard,Berna,Bernt", "Josefina,Josefin",
      "Henrietta,Harriet,Harry", "Signe,Signar,Signy",
      "Bartolomeus,Carita,Rita", "Lovisa,Louis,Louise",
      "sten,Ejvind,jvind", "Rolf,Raoul,Rasmus", "Augustin,Gusti,Gurli",
      "Hans,Hampus,Hasse", "Albert,Albrekt,Aste", "Arvid,Arvida,Vidar",
      "Samuel,Sam,Solveig", "Justus,Jane,Judit", "Alfhild,Alfons,Arja",
      "Moses,Molly,My", "Adela,Adele,Adin", "Sakarias,Siv,Sivert",
      "Regina,Gilbert,Gisela", "Alma,Adils,Almar", "Augusta,Gunda,Gunde",
      "Tord,Tordis,Torgil", "Dagny,Dag,Daga", "Tyra,Tyr",
      "Ambjrn,Stig,Styrbjrn", "Ida,Idar,Vida", "Sigrid,Siri,Solbritt",
      "Eufemia,Cornelia,Cornelius", "Hildegard,Hilbert,Hildebrand",
      "Alvar,Alva,Alve", "Fredrika,Frej,Freja", "Agda,Jan,Jannika",
      "Matteus,Majbritt,Majlis", "Maurits,Marlene,Moritz",
      "Tekla,Trond,Tryggve", "Gerhard,Gert,Glenn",
      "Signhild,Sanfrid,Signhild", "Enar,Einar,Eja",
      "Dagmar,Donald,Douglas", "Lennart,Lena,Leonard",
      "Mikael,Majken,Mikaela", "Helge,Heidi,Hrje", "r,Ragna,Ragne",
      "Ludvig,Levi,Liv", "Evald,Eila,Eilert", "Frans,Franciska,Frank",
      "Bror,Brage,Bruno", "Jenny,Jennifer,Jens", "Birgitta,Birgit,Britt",
      "Nils,Nilla,Nelly", "Ingrid,Inger,Ingolf", "Helmer,Helmina,Helmy",
      "Erling,Elvin,Elvina", "Valfrid,Ina,Inez", "Teofil,Terje,tjelvar",
      "Manfred,Mandor,Manne", "Hedvig,Hartvig,Hedda",
      "Fingal,Finn,Flemming", "Antonietta,Anette,Tony",
      "Lukas,Lillemor,Lilly", "Tore,Bojan Borghild",
      "Sibylla,Camilla,Kasper", "Birger,Brita,Britta",
      "Seved,Sigvid,Ursula", "Sren,Severin", "Evert,Eivor,Elving",
      "Inga,Ingalill,Ingert", "Amanda,Manda,Mandy",
      "Sabina,Sebastian,Sussy", "Simon,Simeon,Simone",
      "Viola,Vivi,Vivianne", "Elsa,Elsie,Ilse", "Edit,Edgar,Edor", 
      0/*allhelgona */, "Tobias,Tova,Tove", "Hubert,Raymond,Roy",
      "Sverker,Nora,Nore", "Eugen,Ebert,Egil", "Gustav Adolf,Gull,Gulli",
      "Ingegerd,Ingel,Ingela", "Vendela,Vanda,Ville", "Teodor,Tea,Ted",
      "Martin Luther,Mait,Martin", "Mrten,Marion,Morgan",
      "Konrad,Kuno,Kurt", "Kristian,Karsten,Kersti", "Emil,Milly,Mimmi",
      "Leopold,Leif,Lilian", "Edmund,Elida,Elisa",
      "Napoleon,Naemi,Naima", "Magnhild,Magna,Magne",
      "Elisabet,Lisa,Lisbeth", "Pontus,Polly,Povel", "Helga,Helle,Hilde",
      "Cecilia,Cilla,Cissi", "Klemens,Ketty,Kitty",
      "Gudrun,Gullan,Gullvor", "Katarina,Carina,Katrin",
      "Torkel,Torleif", "Astrid,Asta,Astri", "Malte,Malvina,Mia",
      "Sune,Sonja,Synnve", "Anders,Andrea,Andreas", "Oskar,Ole,Ossian",
      "Beata,Beatrice,Betty", "Lydia,Linda,Love", "Barbro,Barbara,Boris",
      "Sven,Svend,Svenning", "Nikolaus,Niklas,nikolina",
      "Agaton,Angela,Angelika", "Virginia,Vera,Vesta", "Anna,Ann,Annie",
      "Malin,Majvor,Malena", "Daniel,Dan,Daniela",
      "Alexander,Pia,Pierre", "Lucia,Lisen,Lisette", "Sten,Stina,Sture",
      "Gottfrid,Kaj,Kajsa", "Assar,Odd,Osvald", "Inge,Ilona,Irmeli",
      "Abraham,Abdon,Gideon", "Isak,Isidor,Isidora", "Israel,Gina,Gitte",
      "Tomas,Tom,Tommy", "Natanael,Natalia,Natan", "Adam,Ada,Adina",
      "Eva,Evita,Evy", "Stefan,Staffan,Stefanie",
      "Johannes,Hannes,Johan", "Abel,Abbe", "Set,Viva,Vivari",
      "Sylvester,Sylve,Sylvi",0});

   constant swedish_namedays_1993= 
   ({ 0, "Svea,Sverker",
      "Alfred,Alfrida", "Rut,Ritva", "Hanna,Hannele", "Baltsar,Kasper",
      "August,Augusta", "Erland,Erhard", "Gunnar,Gunder",
      "Sigurd,Sigmund", "Hugo,Hagar", "Frideborg,Fridolf", "Knut",
      "Felix,Felicia", "Laura,Liv", "Hjalmar,Hervor", "Anton,Tony",
      "Hilda,Hildur", "Henrik,Henry", "Fabian,Sebastian", "Agnes,Agneta",
      "Vincent,Veine", "Emilia,Emilie", "Erika,Eira", "Paul,Pl",
      "Bodil,Boel", "Gte,Gta", "Karl,Karla", "Valter,Vilma",
      "Gunhild,Gunilla", "Ivar,Joar", "Max,Magda", "Marja,Mia",
      "Disa,Hjrdis", "Ansgar,Anselm", "Lisa,Elise", "Dorotea,Dora",
      "Rikard,Dick", "Berta,Berthold", "Fanny,Betty", "Egon,Egil",
      "Yngve,Ingolf", "Evelina,Evy", "Agne,Agnar", "Valentin,Tina",
      "Sigfrid,Sigbritt", "Julia,Jill", "Alexandra,Sandra",
      "Frida,Fritz", "Gabriella,Ella", "Rasmus,Ruben", "Hilding,Hulda",
      "Marina,Marlene", "Torsten,Torun", "Mattias,Mats",
      "Sigvard,Sivert", "Torgny,Torkel", "Lage,Laila", "Maria,Maja",
      "Albin,Inez", "Ernst,Erna", "Gunborg,Gunvor", "Adrian,Ada",
      "Tora,Tor", "Ebba,Ebbe", "Isidor,Doris", "Siv,Saga",
      "Torbjrn,Ambjrn", "Edla,Ethel", "Edvin,Elon", "Viktoria,Viktor",
      "Greger,Iris", "Matilda,Maud", "Kristofer,Christel",
      "Herbert,Gilbert", "Gertrud,Grel", "Edvard,Eddie",
      "Josef,Josefina", "Joakim,Kim", "Bengt,Benny", "Viking,Vilgot",
      "Gerda,Gert", "Gabriel,Rafael", "Mary,Marion", "Emanuel,Manne",
      "Ralf,Raymond", "Elma,Elmer", "Jonas,Jens", "Holger,Reidar",
      "Ester,Estrid", "Harald,Halvar", "Gunnel,Gun",
      "Ferdinand,Florence", "Irene,Irja", "Nanna,Nanny", "Vilhelm,Willy",
      "Irma,Mimmi", "Vanja,Ronja", "Otto,Ottilia", "Ingvar,Ingvor",
      "Ulf,Ylva", "Julius,Gillis", "Artur,Douglas", "Tiburtius,Tim",
      "Olivia,Oliver", "Patrik,Patricia", "Elias,Elis",
      "Valdemar,Volmar", "Olaus,Ola", "Amalia,Amelie", "Annika,Anneli",
      "Allan,Alida", "Georg,Gran", "Vega,Viveka", "Markus,Mark",
      "Teresia,Terese", "Engelbrekt,Enok", "Ture,Tyko", "Kennet,Kent",
      "Mariana,Marianne", "Valborg,Maj", "Filip,Filippa", "John,Jack",
      "Monika,Mona", "Vivianne,Vivan", "Marit,Rita", "Lilian,Lilly",
      "ke,Ove", "Jonatan,Gideon", "Elvira,Elvy", "Mrta,Mrit",
      "Charlotta,Lotta", "Linnea,Nina", "Lillemor,Lill", "Sofia,Sonja",
      "Hilma,Hilmer", "Nore,Nora", "Erik,Jerker", "Majken,Majvor",
      "Karolina,Lina", "Konstantin,Conny", "Henning,Hemming",
      "Desiree,Renee", "Ivan,Yvonne", "Urban,Ursula", "Vilhelmina,Helmy",
      "Blenda,Beda", "Ingeborg,Borghild", "Jean,Jeanette",
      "Fritiof,Frej", "Isabella,Isa", "Rune,Runa", "Rutger,Roger",
      "Ingemar,Gudmar", "Solveig,Solbritt", "Bo,Boris", "Gustav,Gsta",
      "Robert,Robin", "Eivor,Elaine", "Petra,Petronella",
      "Kerstin,Karsten", "Bertil,Berit", "Eskil,Esbjrn", "Aina,Eila",
      "Hkan,Heidi", "Margit,Mait", "Axel,Axelina", "Torborg,Torvald",
      "Bjrn,Bjarne", "Germund,Jerry", "Linda,Linn", "Alf,Alva",
      "Paulina,Paula", "Adolf,Adela", "Johan,Jan", "David,Salomon",
      "Gunni,Jim", "Selma,Herta", "Leo,Leopold", "Petrus,Peter",
      "Elof,Leif", "Aron,Mirjam", "Rosa,Rosita", "Aurora,Adina",
      "Ulrika,Ulla", "Melker,Agaton", "Ronald,Ronny", "Klas,Kaj",
      "Kjell,Tjelvar", "Jrgen,rjan", "Anund,Gunda", "Eleonora,Ellinor",
      "Herman,Hermine", "Joel,Judit", "Folke,Odd", "Ragnhild,Ragnvald",
      "Reinhold,Reine", "Alexis,Alice", "Fredrik,Fred", "Sara,Sally",
      "Margareta,Greta", "Johanna,Jane", "Magdalena,Madeleine",
      "Emma,Emmy", "Kristina,Stina", "Jakob,James", "Jesper,Jessika",
      "Marta,Moa", "Botvid,Seved", "Olof,Olle", "Algot,Margot",
      "Elin,Elna", "Per,Pernilla", "Karin,Kajsa", "Tage,Tanja",
      "Arne,Arnold", "Ulrik,Alrik", "Sixten,Slve", "Dennis,Donald",
      "Silvia,Sylvia", "Roland,Roine", "Lars,Lorentz", "Susanna,Sanna",
      "Klara,Clary", "Hillevi,Gullvi", "William,Bill", "Stella,Stellan",
      "Brynolf,Sigyn", "Verner,Veronika", "Helena,Lena", "Magnus,Mns",
      "Bernhard,Bernt", "Jon,Jonna", "Henrietta,Henny", "Signe,Signhild",
      "Bartolomeus,Bert", "Lovisa,Louise", "sten,Ejvind", "Rolf,Rudolf",
      "Gurli,Gull", "Hans,Hampus", "Albert,Albertina", "Arvid,Vidar",
      "Samuel,Sam", "Justus,Justina", "Alfhild,Alfons", "Gisela,Glenn",
      "Harry,Harriet", "Sakarias,Esaias", "Regina,Roy", "Alma,Ally",
      "Anita,Anja", "Tord,Tove", "Dagny,Daniela", "Tyra,sa",
      "Sture,Styrbjrn", "Ida,Ellida", "Sigrid,Siri", "Dag,Daga",
      "Hildegard,Magnhild", "Alvar,Orvar", "Fredrika,Carita",
      "Agda,Agata", "Ellen,Elly", "Maurits,Morgan", "Tekla,Tea",
      "Gerhard,Gert", "Kre,Tryggve", "Einar,Enar", "Dagmar,Rigmor",
      "Lennart,Leonard", "Mikael,Mikaela", "Helge,Helny", "Ragnar,Ragna",
      "Ludvig,Louis", "Evald,Osvald", "Frans,Frank", "Bror,Bruno",
      "Jenny,Jennifer", "Birgitta,Britta", "Nils,Nelly", "Ingrid,Inger",
      "Helmer,Hadar", "Erling,Jarl", "Valfrid,Ernfrid", "Birgit,Britt",
      "Manfred,Helfrid", "Hedvig,Hedda", "Fingal,Finn",
      "Antonia,Annette", "Lukas,Matteus", "Tore,Torleif",
      "Sibylla,Camilla", "Birger,Brje", "Marika,Marita",
      "Sren,Severin", "Evert,Eilert", "Inga,Ingvald", "Amanda,My",
      "Sabina,Ina", "Simon,Simone", "Viola,Vivi", "Elsa,Elsie",
      "Edit,Edgar", "Andre,Andrea", "Tobias,Toini", "Hubert,Diana",
      "Uno,Unn", "Eugen,Eugenia", "Gustav Adolf", "Ingegerd,Ingela",
      "Vendela,Vanda", "Teodor,Ted", "Martin,Martina", "Mrten",
      "Konrad,Kurt", "Kristian,Krister", "Emil,Mildred", "Katja,Nadja",
      "Edmund,Gudmund", "Naemi,Nancy", "Pierre,Percy",
      "Elisabet,Lisbeth", "Pontus,Pia", "Helga,Olga", "Cecilia,Cornelia",
      "Klemens,Clarence", "Gudrun,Runar", "Katarina,Carina",
      "Linus,Love", "Astrid,Asta", "Malte,Malkolm", "Sune,Synnve",
      "Anders,Andreas", "Oskar,Ossian", "Beata,Beatrice", "Lydia,Carola",
      "Barbro,Barbara", "Sven,Svante", "Nikolaus,Niklas",
      "Angelika,Angela", "Virginia,Vera", "Anna,Annie", "Malin,Malena",
      "Daniel,Dan", "Alexander,Alex", "Lucia", "Sten,Stig",
      "Gottfrid,Gotthard", "Assar,Astor", "Inge,Ingemund",
      "Abraham,Efraim", "Isak,Rebecka", "Israel,Moses", "Tomas,Tom",
      "Natanael,Natalia", "Adam", "Eva", 0, "Stefan,Staffan",
      "Johannes,Hannes", "Abel,Set", "Gunlg,slg", "Sylvester", 0});

}

class Hungary
{
   inherit Namedays;

   mapping lookup=0;

   void create()
   {
      name="Sweden";
   }

   static array(string) namedays_year(int y)
   {
      return hungarian_namedays;
   }

   static int nameday_lookup(int y,string s)
   {
      return (lookup||
	      (lookup=make_lookup(hungarian_namedays)))
	 [lower_case(s)];
   }

   constant hungarian_namedays=
   ({
      "Fruzsina",
      "bel",
      "Genovna,Benjmin",
      "Titusz,Lena,Angla",
      "Simon,Amata",
      "Boldizsr",
      "Attila,Ramna",
      "Gyngyvr",
      "Marcell",
      "Melnia",
      "gota",
      "Ern",
      "Veronika",
      "Bdog",
      "Lrnt,Lrnd",
      "Gusztv",
      "Antal,Antnia",
      "Piroska",
      "Sra,Mri",
      "Fbin,Sebestyn",
      "gnes",
      "Vince,Artr,Anasztz",
      "Zelma,Rajmund",
      "Timt",
      "Pl",
      "Vanda,Paula",
      "Angelika,Angla",
      "Kroly,Karola",
      "Adl",
      "Martina,Gerda",
      "Marcella",
      "Ignc",
      "Karolina,Aida",
      "Balzs",
      "Rhel,Csenge,Andrs",
      "gota,Ingrid",
      "Dorottya,Dra,Ajndk,Amanda",
      "Tdor,Rme",
      "Aranka",
      "Abigl,Alex",
      "Elvira",
      "Bertold,Marietta,Adolf",
      "Lvia,Ldia",
      "Ella,Linda",
      "Blint,Valentin",
      "Kolos,Georgina",
      "Julianna,Lilla",
      "Dont",
      "Bernadett",
      "Zsuzsanna",
      "Aladr,lmos,Amata",
      "Eleonra",
      "Gerzson",
      "Alfrd",
      "Mtys",
      "Gza",
      "Edina",
      "kos,Btor",
      "Elemr",
      "Albin,Albina",
      "Lujza",
      "Kornlia",
      "Kzmr,Adorjn,Adrin,Adrienn",
      "Adorjn,Adrin,Adrienn",
      "Leonora,Inez",
      "Tams",
      "Zoltn",
      "Franciska,Fanni",
      "Ildik",
      "Szilrd,Aladr",
      "Gergely",
      "Krisztin,Ajtny",
      "Matild",
      "Kristf",
      "Henrietta",
      "Gertrd,Patrik",
      "Sndor,Ede,Alexandra",
      "Jzsef,Bnk",
      "Klaudia",
      "Benedek",
      "Beta,Izolda",
      "Emke",
      "Gbor,Karina",
      "Irn,risz",
      "Emnuel",
      "Hajnalka",
      "Gedeon,Johanna",
      "Aguszta",
      "Zaln,Amade",
      "rpd,Ajtny",
      "Hug",
      "ron",
      "Buda,Richrd",
      "Izidor",
      "Vince",
      "Vilmos,Bborka",
      "Herman",
      "Dnes",
      "Erhard",
      "Zsolt",
      "Le,Szaniszl",
      "Gyula",
      "Ida",
      "Tibor",
      "Anasztzia,Tas",
      "Csongor",
      "Rudolf",
      "Andrea,Ilma,Andrs",
      "Emma",
      "Tivadar",
      "Konrd",
      "Csilla,Nomi",
      "Bla",
      "Gyrgy",
      "Mrk",
      "Ervin",
      "Zita",
      "Valria",
      "Pter,Albert,Albertna",
      "Katalin,Kitti",
      "Flp,Jakab,Amarilla",
      "Zsigmond",
      "Tmea,Irma",
      "Mnika,Flrin",
      "Gyrgyi",
      "Ivett,Frida",
      "Gizella",
      "Mihly",
      "Gergely",
      "rmin,Plma",
      "Ferenc,Adolf",
      "Pongrc",
      "Szervc,Imola",
      "Bonifc",
      "Zsfia,Szonja",
      "Mzes,Botond",
      "Paszkl",
      "Erik,Alexandra",
      "Iv,Miln",
      "Bernt,Felcia",
      "Konstantin,Andrs",
      "Jlia,Rita",
      "Dezs",
      "Eszter,Eliza",
      "Orbn",
      "Flp,Evelin,Amanda",
      "Hella",
      "Emil,Csand,goston",
      "Magdolna",
      "Janka,Zsanett",
      "Angla,Petronella",
      "Tnde",
      "Krmen,Anita,Anna,Annamria",
      "Klotild",
      "Bulcs",
      "Fatime",
      "Norbert,Cintia",
      "Rbert",
      "Medrd",
      "Flix,Annabella",
      "Margit,Grta",
      "Barnabs",
      "Vill",
      "Antal,Anett,Anna",
      "Vazul",
      "Joln,Vid",
      "Jusztin",
      "Laura,Alida,Adolf,Alina,Alinda",
      "Arnold,Levente",
      "Gyrfs",
      "Rafael",
      "Alajos,Leila,Aladr,Aloma",
      "Paulina",
      "Zoltn",
      "Ivn",
      "Vilmos",
      "Jnos,Pl",
      "Lszlo",
      "Levente,Irn",
      "Pter,Pl",
      "Pl",
      "Tihamr,Annamria",
      "Ott",
      "Kornl,Soma,Anatol",
      "Ulrik",
      "Emese,Sarolta,Antal",
      "Csaba",
      "Apollonia",
      "Ellk",
      "Lukrcia",
      "Amlia,Alma",
      "Nra,Lili",
      "Izabella,Dalma",
      "Jen",
      "rs,Stella",
      "Henrik,Roland",
      "Valter",
      "Endre,Elek,Ajndk,Andrs",
      "Frigyes",
      "Emlia",
      "lls",
      "Dniel,Daniella",
      "Magdolna",
      "Lenke",
      "Kinga,Kincs",
      "Kristf,Jakab",
      "Anna,Anik,Annamria",
      "Olga,Liliana,Ajtny",
      "Szabolcs",
      "Mrta,Flra",
      "Judit,Xnia",
      "Oszkr",
      "Boglrka",
      "Lehel,Alfonz",
      "Hermina",
      "Domonkos,Dominika",
      "Krisztina,Afrodit",
      "Berta,Bettna",
      "Ibolya,Afrodit",
      "Lszl",
      "Emd",
      "Lrinc",
      "Zsuzsanna,Tiborc",
      "Klra",
      "Ipoly",
      "Marcell",
      "Mria",
      "brahm",
      "Jcint,Anasztz",
      "Ilona",
      "Huba",
      "Istvn",
      "Smuel,Hajna",
      "Menyhrt,Mirjam",
      "Bence",
      "Bertalan",
      "Lajos,Patrcia",
      "Izs",
      "Gspr",
      "goston",
      "Beatrix,Erna",
      "Rzsa",
      "Erika,Bella",
      "Egyed,Egon",
      "Rebeka,Dorina",
      "Hilda",
      "Rozlia",
      "Viktor,Lrinc,Alpr",
      "Zakaris",
      "Regina",
      "Mria,Adrienn,Adorjn,Adrin",
      "dm,Andrs",
      "Nikolett,Hunor",
      "Teodra",
      "Mria",
      "Kornl,Amata",
      "Szerna,Roxna",
      "Enik,Melitta",
      "Edit",
      "Zsfia",
      "Dina",
      "Vilhelmina",
      "Friderika",
      "Mt,Mirella",
      "Mric",
      "Tekla",
      "Gellrt,Mercdesz",
      "Eufrzina,Kende",
      "Jusztina",
      "Adalbert,Adolf,Albertina",
      "Vencel",
      "Mihly",
      "Jeromos",
      "Malvin",
      "Petra",
      "Helga",
      "Ferenc",
      "Aurl",
      "Brn,Renta",
      "Amlia",
      "Koppny",
      "Dnes",
      "Gedeon",
      "Brigitta",
      "Miksa",
      "Klmn,Ede",
      "Heln",
      "Terz",
      "Gl",
      "Hedvig",
      "Lukcs",
      "Nndor",
      "Vendel",
      "Orsolya",
      "Eld",
      "Gyngyi",
      "Salamon",
      "Blanka,Bianka",
      "Dmtr",
      "Szabina",
      "Simon,Szimonetta",
      "Nrcisz",
      "Alfonz",
      "Farkas",
      "Marianna",
      "Achilles",
      "Gyz",
      "Kroly",
      "Imre",
      "Lnrd",
      "Rezs",
      "Zsombor",
      "Tivadar",
      "Rka,Andrs",
      "Mrton",
      "Jns,Rent,Aba",
      "Szilvia",
      "Alz",
      "Albert,Lipt",
      "dn",
      "Hortenzia,Gerg",
      "Jen",
      "Erzsbet",
      "Joln",
      "Olivr",
      "Ceclia",
      "Kelemen,Klementna",
      "Emma",
      "Katalin,Alan",
      "Virg",
      "Virgil",
      "Stefnia",
      "Taksony",
      "Andrs,Andor",
      "Elza",
      "Melinda,Vivien",
      "Ferenc",
      "Borbla,Barbara",
      "Vilma",
      "Mikls",
      "Ambrus",
      "Mria",
      "Natlia",
      "Judit",
      "rpd",
      "Gabriella",
      "Luca,Otlia",
      "Szilrda",
      "Valr",
      "Etelka,Aletta,Albina",
      "Lzr,Olimpia",
      "Auguszta",
      "Viola",
      "Teofil",
      "Tams",
      "Zn",
      "Viktria",
      "dm,va,Ada,Adl",
      "Eugnia",
      "Istvn",
      "Jnos",
      "Kamilla",
      "Tams,Tamara",
      "Dvid",
      "Szilveszter",
      0,
   });
}
