// ----------------------------------------------------------------
// Timezone names
//
// this file is created half-manually
// ----------------------------------------------------------------

//! module Calendar
//! submodule TZnames
//!	This module contains listnings of available timezones,
//!	in some different ways
//!
//! constant mapping(string:array(string)) zones
//!	This constant is a mapping that can be
//!	used to loop over to get all the region-based
//!	timezones. 
//!
//!	It looks like this:
//!	<pre>
//!	([ "America": ({ "Los_Angeles", "Chicago", <i>[...]</i> }),
//!	   "Europe":  ({ "Stockholm", <i>[...]</i> }),
//!        <i>[...]</i> }),
//!	</pre>
//!
//!	Please note that loading all the timezones can take some 
//!	time, since they are generated and compiled on the fly.

mapping zones=
([
   "America":   ({"Scoresbysund","Godthab","Thule","New_York","Chicago",    
                  "Denver","Los_Angeles","Juneau","Yakutat","Anchorage",    
                  "Nome","Adak","Phoenix","Boise","Indianapolis",           
                  "Indiana/Marengo","Indiana/Knox","Indiana/Vevay",           
                  "Louisville","Detroit","Menominee","St_Johns","Goose_Bay",
                  "Halifax","Glace_Bay","Montreal","Thunder_Bay","Nipigon", 
                  "Rainy_River","Winnipeg","Regina","Swift_Current",         
                  "Edmonton","Vancouver","Dawson_Creek","Pangnirtung",       
                  "Iqaluit","Rankin_Inlet","Cambridge_Bay","Yellowknife",    
                  "Inuvik","Whitehorse","Dawson","Cancun","Mexico_City",    
                  "Chihuahua","Hermosillo","Mazatlan","Tijuana","Anguilla", 
                  "Antigua","Nassau","Barbados","Belize","Cayman",          
                  "Costa_Rica","Havana","Dominica","Santo_Domingo",          
                  "El_Salvador","Grenada","Guadeloupe","Guatemala",          
                  "Port-au-Prince","Tegucigalpa","Jamaica","Martinique",     
                  "Montserrat","Managua","Panama","Puerto_Rico","St_Kitts", 
                  "St_Lucia","Miquelon","St_Vincent","Grand_Turk","Tortola",
                  "St_Thomas","Buenos_Aires","Rosario","Cordoba","Jujuy",   
                  "Catamarca","Mendoza","Aruba","La_Paz","Noronha","Belem",
                  "Fortaleza","Araguaina","Maceio","Sao_Paulo","Cuiaba",    
                  "Porto_Velho","Boa_Vista","Manaus","Porto_Acre","Santiago",
                  "Bogota","Curacao","Guayaquil","Cayenne","Guyana",        
                  "Asuncion","Lima","Paramaribo","Port_of_Spain",            
                  "Montevideo","Caracas"}),                    
   "Pacific":   ({"Rarotonga","Fiji","Gambier","Marquesas","Tahiti","Guam",
                  "Tarawa","Enderbury","Kiritimati","Saipan","Majuro",      
                  "Kwajalein","Yap","Truk","Ponape","Kosrae","Nauru",      
                  "Noumea","Auckland","Chatham","Niue","Norfolk","Palau",  
                  "Port_Moresby","Pitcairn","Pago_Pago","Apia","Guadalcanal",
                  "Fakaofo","Tongatapu","Funafuti","Johnston","Midway",     
                  "Wake","Efate","Wallis","Honolulu","Easter","Galapagos"}),
   "Antarctica":({"Casey","Davis","Mawson","DumontDUrville","Syowa",        
                  "Palmer","McMurdo"}),                        
   "Atlantic":  ({"Cape_Verde","St_Helena","Faeroe","Reykjavik","Jan_Mayen",
                  "Azores","Madeira","Canary","Bermuda","Stanley",          
                  "South_Georgia"}),                            
   "Indian":    ({"Comoro","Antananarivo","Mauritius","Mayotte","Reunion",  
                  "Mahe","Kerguelen","Chagos","Maldives","Christmas",       
                  "Cocos"}),                                    
   "Europe":    ({"London","Belfast","Dublin","Tirane","Andorra","Vienna", 
                  "Minsk","Brussels","Sofia","Prague","Copenhagen",         
                  "Tallinn","Helsinki","Paris","Berlin","Gibraltar",        
                  "Athens","Budapest","Rome","Riga","Vaduz","Vilnius",     
                  "Luxembourg","Malta","Chisinau","Tiraspol","Monaco",      
                  "Amsterdam","Oslo","Warsaw","Lisbon","Bucharest",         
                  "Kaliningrad","Moscow","Samara","Madrid","Stockholm",     
                  "Zurich","Istanbul","Kiev","Uzhgorod","Zaporozhye",       
                  "Simferopol","Belgrade"}),                   
   "Africa":    ({"Algiers","Luanda","Porto-Novo","Gaborone","Ouagadougou", 
                  "Bujumbura","Douala","Bangui","Ndjamena","Kinshasa",      
                  "Lubumbashi","Brazzaville","Abidjan","Djibouti","Cairo",  
                  "Malabo","Asmera","Addis_Ababa","Libreville","Banjul",    
                  "Accra","Conakry","Bissau","Nairobi","Maseru","Monrovia",
                  "Tripoli","Blantyre","Bamako","Timbuktu","Nouakchott",    
                  "Casablanca","El_Aaiun","Maputo","Windhoek","Niamey",     
                  "Lagos","Kigali","Sao_Tome","Dakar","Freetown",           
                  "Mogadishu","Johannesburg","Khartoum","Mbabane",           
                  "Dar_es_Salaam","Lome","Tunis","Kampala","Lusaka",        
                  "Harare","Ceuta"}),                          
   "Asia":      ({"Kabul","Yerevan","Baku","Bahrain","Dacca","Thimbu",     
                  "Brunei","Rangoon","Phnom_Penh","Harbin","Shanghai",      
                  "Chungking","Urumqi","Kashgar","Hong_Kong","Taipei",      
                  "Macao","Nicosia","Tbilisi","Dili","Calcutta","Jakarta", 
                  "Ujung_Pandang","Jayapura","Tehran","Baghdad","Jerusalem",
                  "Tokyo","Amman","Almaty","Aqtobe","Aqtau","Bishkek",     
                  "Seoul","Pyongyang","Kuwait","Vientiane","Beirut",        
                  "Kuala_Lumpur","Kuching","Hovd","Ulaanbaatar","Katmandu", 
                  "Muscat","Karachi","Gaza","Manila","Qatar","Riyadh",     
                  "Singapore","Colombo","Damascus","Dushanbe","Bangkok",    
                  "Ashkhabad","Dubai","Samarkand","Tashkent","Saigon",      
                  "Aden","Yekaterinburg","Omsk","Novosibirsk","Krasnoyarsk",
                  "Irkutsk","Yakutsk","Vladivostok","Magadan","Kamchatka",  
                  "Anadyr"}),                                   
   "Australia": ({"Darwin","Perth","Brisbane","Lindeman","Adelaide",        
                  "Hobart","Melbourne","Sydney","Broken_Hill","Lord_Howe"}),
]);

// this is used to dwim timezone

//! constant mapping(string:array(string)) abbr2zones
//!	This mapping is used to look up abbreviation
//!	to the possible regional zones. 
//!
//!	It looks like this:
//!	<pre>
//!	([ "CET": ({ "Europe/Stockholm", <i>[...]</i> }),
//!	   "CST": ({ "America/Chicago", "Australia/Adelaide", <i>[...]</i> }),
//!        <i>[...]</i> }),
//!	</pre>
//!
//!	Note this: Just because it's noted "CST" doesn't mean it's a
//!	unique timezone. There is about 7 *different* timezones that
//!	uses "CST" as abbreviation; not at the same time,
//!	though, so the DWIM routines checks this before
//!	it's satisfied. Same with some other timezones. 
//!
//!     For most timezones, there is a number of region timezones that for the
//!     given time are equal. This is because region timezones include rules
//!     about local summer time shifts and possible historic shifts.
//!
//!	The <ref>YMD.parse</ref> functions can handle timezone abbreviations
//!	by guessing.

mapping abbr2zones=
([
   "ACST": ({"America/Porto_Acre"}),                                           
   "ACT": ({"America/Porto_Acre"}),                                            
   "ADDT": ({"America/Pangnirtung"}),                                          
   "ADMT": ({"Africa/Asmera", "Africa/Addis_Ababa"}),                          
   "ADT": ({"Atlantic/Bermuda", "Asia/Baghdad", "America/Thule",               
       "America/Goose_Bay", "America/Halifax", "America/Glace_Bay",       
       "America/Pangnirtung", "America/Barbados", "America/Martinique"}), 
   "AFT": ({"Asia/Kabul"}),                                                    
   "AHDT": ({"America/Anchorage"}),                                            
   "AHST": ({"America/Anchorage"}),                                            
   "AHWT": ({"America/Anchorage"}),                                            
   "AKDT": ({"America/Juneau", "America/Yakutat", "America/Anchorage",         
       "America/Nome"}),                                                 
   "AKST": ({"Asia/Aqtobe", "America/Juneau", "America/Yakutat",               
       "America/Anchorage", "America/Nome"}),                            
   "AKT": ({"Asia/Aqtobe"}),                                                   
   "AKTST": ({"Asia/Aqtobe"}),                                                 
   "AKWT": ({"America/Juneau", "America/Yakutat", "America/Anchorage",         
       "America/Nome"}),                                                 
   "ALMST": ({"Asia/Almaty"}),                                                 
   "ALMT": ({"Asia/Almaty"}),                                                  
   "AMST": ({"Asia/Yerevan", "America/Cuiaba", "America/Porto_Velho",          
       "America/Boa_Vista", "America/Manaus"}),                          
   "AMT": ({"Europe/Athens", "Europe/Amsterdam", "Asia/Yerevan",               
       "Africa/Asmera", "America/Cuiaba", "America/Porto_Velho",          
       "America/Boa_Vista", "America/Manaus", "America/Asuncion"}),       
   "ANAMT": ({"Asia/Anadyr"}),                                                 
   "ANAST": ({"Asia/Anadyr"}),                                                 
   "ANAT": ({"Asia/Anadyr"}),                                                  
   "ANT": ({"America/Aruba", "America/Curacao"}),                              
   "AQTST": ({"Asia/Aqtobe", "Asia/Aqtau"}),                                   
   "AQTT": ({"Asia/Aqtobe", "Asia/Aqtau"}),                                    
   "ARST": ({"Antarctica/Palmer", "America/Buenos_Aires", "America/Rosario",   
       "America/Cordoba", "America/Jujuy", "America/Catamarca",          
       "America/Mendoza"}),                                              
   "ART": ({"Antarctica/Palmer", "America/Buenos_Aires", "America/Rosario",    
       "America/Cordoba", "America/Jujuy", "America/Catamarca",           
       "America/Mendoza"}),                                               
   "ASHST": ({"Asia/Ashkhabad"}),                                              
   "ASHT": ({"Asia/Ashkhabad"}),                                               
   "AST": ({"Atlantic/Bermuda", "Asia/Bahrain", "Asia/Baghdad", "Asia/Kuwait", 
       "Asia/Qatar", "Asia/Riyadh", "Asia/Aden", "America/Thule",         
       "America/Goose_Bay", "America/Halifax", "America/Glace_Bay",       
       "America/Pangnirtung", "America/Anguilla", "America/Antigua",      
       "America/Barbados", "America/Dominica", "America/Santo_Domingo",   
       "America/Grenada", "America/Guadeloupe", "America/Martinique",     
       "America/Montserrat", "America/Puerto_Rico", "America/St_Kitts",   
       "America/St_Lucia", "America/Miquelon", "America/St_Vincent",      
       "America/Tortola", "America/St_Thomas", "America/Aruba",           
       "America/Curacao", "America/Port_of_Spain"}),                      
   "AWT": ({"America/Puerto_Rico"}),                                           
   "AZOST": ({"Atlantic/Azores"}),                                             
   "AZOT": ({"Atlantic/Azores"}),                                              
   "AZST": ({"Asia/Baku"}),                                                    
   "AZT": ({"Asia/Baku"}),                                                     
   "BAKST": ({"Asia/Baku"}),                                                   
   "BAKT": ({"Asia/Baku"}),                                                    
   "BDT": ({"Asia/Dacca", "America/Nome", "America/Adak"}),                    
   "BEAT": ({"Africa/Nairobi", "Africa/Mogadishu", "Africa/Kampala"}),         
   "BEAUT": ({"Africa/Nairobi", "Africa/Dar_es_Salaam", "Africa/Kampala"}),    
   "BMT": ({"Europe/Brussels", "Europe/Chisinau", "Europe/Tiraspol",           
       "Europe/Bucharest", "Europe/Zurich", "Asia/Baghdad",               
       "Asia/Bangkok", "Africa/Banjul", "America/Barbados",               
       "America/Bogota"}),                                                
   "BNT": ({"Asia/Brunei"}),                                                   
   "BORT": ({"Asia/Ujung_Pandang", "Asia/Kuching"}),                           
   "BOST": ({"America/La_Paz"}),                                               
   "BOT": ({"America/La_Paz"}),                                                
   "BRST": ({"America/Belem", "America/Fortaleza", "America/Araguaina",        
       "America/Maceio", "America/Sao_Paulo"}),                          
   "BRT": ({"America/Belem", "America/Fortaleza", "America/Araguaina",         
       "America/Maceio", "America/Sao_Paulo"}),                           
   "BST": ({"Europe/London", "Europe/Belfast", "Europe/Dublin",                
       "Europe/Gibraltar", "Pacific/Pago_Pago", "Pacific/Midway",         
       "America/Nome", "America/Adak"}),                                  
   "BTT": ({"Asia/Thimbu"}),                                                   
   "BURT": ({"Asia/Dacca", "Asia/Rangoon", "Asia/Calcutta"}),                  
   "BWT": ({"America/Nome", "America/Adak"}),                                  
   "CANT": ({"Atlantic/Canary"}),                                              
   "CAST": ({"Africa/Gaborone", "Africa/Khartoum"}),                           
   "CAT": ({"Africa/Gaborone", "Africa/Bujumbura", "Africa/Lubumbashi",        
       "Africa/Blantyre", "Africa/Maputo", "Africa/Windhoek",             
       "Africa/Kigali", "Africa/Khartoum", "Africa/Lusaka",               
       "Africa/Harare", "America/Anchorage"}),                            
   "CCT": ({"Indian/Cocos"}),                                                  
   "CDDT": ({"America/Rankin_Inlet"}),                                         
   "CDT": ({"Asia/Harbin", "Asia/Shanghai", "Asia/Chungking", "Asia/Urumqi",   
       "Asia/Kashgar", "Asia/Taipei", "Asia/Macao", "America/Chicago",    
       "America/Indianapolis", "America/Indiana/Marengo",                 
       "America/Indiana/Knox", "America/Indiana/Vevay",                   
       "America/Louisville", "America/Menominee", "America/Rainy_River",  
       "America/Winnipeg", "America/Pangnirtung", "America/Iqaluit",      
       "America/Rankin_Inlet", "America/Cambridge_Bay", "America/Cancun", 
       "America/Mexico_City", "America/Chihuahua", "America/Belize",      
       "America/Costa_Rica", "America/Havana", "America/El_Salvador",     
       "America/Guatemala", "America/Tegucigalpa", "America/Managua"}),   
   "CEST": ({"Europe/Tirane", "Europe/Andorra", "Europe/Vienna",               
       "Europe/Minsk", "Europe/Brussels", "Europe/Sofia",                
       "Europe/Prague", "Europe/Copenhagen", "Europe/Tallinn",           
       "Europe/Berlin", "Europe/Gibraltar", "Europe/Athens",             
       "Europe/Budapest", "Europe/Rome", "Europe/Riga", "Europe/Vaduz",  
       "Europe/Vilnius", "Europe/Luxembourg", "Europe/Malta",            
       "Europe/Chisinau", "Europe/Tiraspol", "Europe/Monaco",            
       "Europe/Amsterdam", "Europe/Oslo", "Europe/Warsaw",               
       "Europe/Lisbon", "Europe/Kaliningrad", "Europe/Madrid",           
       "Europe/Stockholm", "Europe/Zurich", "Europe/Kiev",               
       "Europe/Uzhgorod", "Europe/Zaporozhye", "Europe/Simferopol",      
       "Europe/Belgrade", "Africa/Algiers", "Africa/Tripoli",            
       "Africa/Tunis", "Africa/Ceuta"}),                                 
   "CET": ({"Europe/Tirane", "Europe/Andorra", "Europe/Vienna", "Europe/Minsk",
       "Europe/Brussels", "Europe/Sofia", "Europe/Prague",                
       "Europe/Copenhagen", "Europe/Tallinn", "Europe/Berlin",            
       "Europe/Gibraltar", "Europe/Athens", "Europe/Budapest",            
       "Europe/Rome", "Europe/Riga", "Europe/Vaduz", "Europe/Vilnius",    
       "Europe/Luxembourg", "Europe/Malta", "Europe/Chisinau",            
       "Europe/Tiraspol", "Europe/Monaco", "Europe/Amsterdam",            
       "Europe/Oslo", "Europe/Warsaw", "Europe/Lisbon",                   
       "Europe/Kaliningrad", "Europe/Madrid", "Europe/Stockholm",         
       "Europe/Zurich", "Europe/Kiev", "Europe/Uzhgorod",                 
       "Europe/Zaporozhye", "Europe/Simferopol", "Europe/Belgrade",       
       "Africa/Algiers", "Africa/Tripoli", "Africa/Casablanca",           
       "Africa/Tunis", "Africa/Ceuta"}),                                  
   "CGST": ({"America/Scoresbysund"}),                                         
   "CGT": ({"America/Scoresbysund"}),                                          
   "CHDT": ({"America/Belize"}),                                               
   "CHUT": ({"Asia/Chungking"}),                                               
   "CJT": ({"Asia/Tokyo"}),                                                    
   "CKHST": ({"Pacific/Rarotonga"}),                                           
   "CKT": ({"Pacific/Rarotonga"}),                                             
   "CLST": ({"Antarctica/Palmer", "America/Santiago"}),                        
   "CLT": ({"Antarctica/Palmer", "America/Santiago"}),                         
   "CMT": ({"Europe/Copenhagen", "Europe/Chisinau", "Europe/Tiraspol",         
       "America/St_Lucia", "America/Buenos_Aires", "America/Rosario",     
       "America/Cordoba", "America/Jujuy", "America/Catamarca",           
       "America/Mendoza", "America/Caracas"}),                            
   "COST": ({"America/Bogota"}),                                               
   "COT": ({"America/Bogota"}),                                                
   "CST": ({"Asia/Harbin", "Asia/Shanghai", "Asia/Chungking", "Asia/Urumqi",   
       "Asia/Kashgar", "Asia/Taipei", "Asia/Macao", "Asia/Jayapura",      
       "Australia/Darwin", "Australia/Adelaide", "Australia/Broken_Hill", 
       "America/Chicago", "America/Indianapolis",                         
       "America/Indiana/Marengo", "America/Indiana/Knox",                 
       "America/Indiana/Vevay", "America/Louisville", "America/Detroit",  
       "America/Menominee", "America/Rainy_River", "America/Winnipeg",    
       "America/Regina", "America/Swift_Current", "America/Pangnirtung",  
       "America/Iqaluit", "America/Rankin_Inlet", "America/Cambridge_Bay",
       "America/Cancun", "America/Mexico_City", "America/Chihuahua",      
       "America/Hermosillo", "America/Mazatlan", "America/Belize",        
       "America/Costa_Rica", "America/Havana", "America/El_Salvador",     
       "America/Guatemala", "America/Tegucigalpa", "America/Managua"}),   
   "CUT": ({"Europe/Zaporozhye"}),                                             
   "CVST": ({"Atlantic/Cape_Verde"}),                                          
   "CVT": ({"Atlantic/Cape_Verde"}),                                           
   "CWT": ({"America/Chicago", "America/Indianapolis",                         
       "America/Indiana/Marengo", "America/Indiana/Knox",                 
       "America/Indiana/Vevay", "America/Louisville",                     
       "America/Menominee"}),                                             
   "CXT": ({"Indian/Christmas"}),                                              
   "DACT": ({"Asia/Dacca"}),                                                   
   "DAVT": ({"Antarctica/Davis"}),                                             
   "DDUT": ({"Antarctica/DumontDUrville"}),                                    
   "DMT": ({"Europe/Belfast", "Europe/Dublin"}),                               
   "DUSST": ({"Asia/Dushanbe"}),                                               
   "DUST": ({"Asia/Dushanbe"}),                                                
   "EASST": ({"Pacific/Easter"}),                                              
   "EAST": ({"Indian/Antananarivo", "Pacific/Easter"}),                        
   "EAT": ({"Indian/Comoro", "Indian/Antananarivo", "Indian/Mayotte",          
       "Africa/Djibouti", "Africa/Asmera", "Africa/Addis_Ababa",          
       "Africa/Nairobi", "Africa/Mogadishu", "Africa/Khartoum",           
       "Africa/Dar_es_Salaam", "Africa/Kampala"}),                        
   "ECT": ({"Pacific/Galapagos", "America/Guayaquil"}),                        
   "EDDT": ({"America/Iqaluit"}),                                              
   "EDT": ({"America/New_York", "America/Indianapolis",                        
       "America/Indiana/Marengo", "America/Indiana/Vevay",                
       "America/Louisville", "America/Detroit", "America/Montreal",       
       "America/Thunder_Bay", "America/Nipigon", "America/Pangnirtung",   
       "America/Iqaluit", "America/Cancun", "America/Nassau",             
       "America/Santo_Domingo", "America/Port-au-Prince",                 
       "America/Jamaica", "America/Grand_Turk"}),                         
   "EEMT": ({"Europe/Minsk", "Europe/Chisinau", "Europe/Tiraspol",             
       "Europe/Kaliningrad", "Europe/Moscow"}),                          
   "EEST": ({"Europe/Minsk", "Europe/Sofia", "Europe/Tallinn",                 
       "Europe/Helsinki", "Europe/Athens", "Europe/Riga",                
       "Europe/Vilnius", "Europe/Chisinau", "Europe/Tiraspol",           
       "Europe/Warsaw", "Europe/Bucharest", "Europe/Kaliningrad",        
       "Europe/Moscow", "Europe/Istanbul", "Europe/Kiev",                
       "Europe/Uzhgorod", "Europe/Zaporozhye", "Asia/Nicosia",           
       "Asia/Amman", "Asia/Beirut", "Asia/Gaza", "Asia/Damascus",        
       "Africa/Cairo"}),                                                 
   "EET": ({"Europe/Minsk", "Europe/Sofia", "Europe/Tallinn",                  
       "Europe/Helsinki", "Europe/Athens", "Europe/Riga",                 
       "Europe/Vilnius", "Europe/Chisinau", "Europe/Tiraspol",            
       "Europe/Warsaw", "Europe/Bucharest", "Europe/Kaliningrad",         
       "Europe/Moscow", "Europe/Istanbul", "Europe/Kiev",                 
       "Europe/Uzhgorod", "Europe/Zaporozhye", "Europe/Simferopol",       
       "Asia/Nicosia", "Asia/Amman", "Asia/Beirut", "Asia/Gaza",          
       "Asia/Damascus", "Africa/Cairo", "Africa/Tripoli"}),               
   "EGST": ({"America/Scoresbysund"}),                                         
   "EGT": ({"Atlantic/Jan_Mayen", "America/Scoresbysund"}),                    
   "EHDT": ({"America/Santo_Domingo"}),                                        
   "EST": ({"Australia/Brisbane", "Australia/Lindeman", "Australia/Hobart",    
       "Australia/Melbourne", "Australia/Sydney", "Australia/Broken_Hill",
       "Australia/Lord_Howe", "America/New_York", "America/Chicago",      
       "America/Indianapolis", "America/Indiana/Marengo",                 
       "America/Indiana/Knox", "America/Indiana/Vevay",                   
       "America/Louisville", "America/Detroit", "America/Menominee",      
       "America/Montreal", "America/Thunder_Bay", "America/Nipigon",      
       "America/Pangnirtung", "America/Iqaluit", "America/Cancun",        
       "America/Antigua", "America/Nassau", "America/Cayman",             
       "America/Santo_Domingo", "America/Port-au-Prince",                 
       "America/Jamaica", "America/Managua", "America/Panama",            
       "America/Grand_Turk"}),                                            
   "EWT": ({"America/New_York", "America/Indianapolis",                        
       "America/Indiana/Marengo", "America/Indiana/Vevay",                
       "America/Louisville", "America/Detroit", "America/Jamaica"}),      
   "FFMT": ({"America/Martinique"}),                                           
   "FJST": ({"Pacific/Fiji"}),                                                 
   "FJT": ({"Pacific/Fiji"}),                                                  
   "FKST": ({"Atlantic/Stanley"}),                                             
   "FKT": ({"Atlantic/Stanley"}),                                              
   "FMT": ({"Atlantic/Madeira", "Africa/Freetown"}),                           
   "FNST": ({"America/Noronha"}),                                              
   "FNT": ({"America/Noronha"}),                                               
   "FRUST": ({"Asia/Bishkek"}),                                                
   "FRUT": ({"Asia/Bishkek"}),                                                 
   "GALT": ({"Pacific/Galapagos"}),                                            
   "GAMT": ({"Pacific/Gambier"}),                                              
   "GBGT": ({"America/Guyana"}),                                               
   "GEST": ({"Asia/Tbilisi"}),                                                 
   "GET": ({"Asia/Tbilisi"}),                                                  
   "GFT": ({"America/Cayenne"}),                                               
   "GHST": ({"Africa/Accra"}),                                                 
   "GILT": ({"Pacific/Tarawa"}),                                               
   "GMT": ({"Atlantic/St_Helena", "Atlantic/Reykjavik", "Europe/London",       
       "Europe/Belfast", "Europe/Dublin", "Europe/Gibraltar",             
       "Africa/Porto-Novo", "Africa/Ouagadougou", "Africa/Abidjan",       
       "Africa/Malabo", "Africa/Banjul", "Africa/Accra", "Africa/Conakry",
       "Africa/Bissau", "Africa/Monrovia", "Africa/Bamako",               
       "Africa/Timbuktu", "Africa/Nouakchott", "Africa/Niamey",           
       "Africa/Sao_Tome", "Africa/Dakar", "Africa/Freetown",              
       "Africa/Lome"}),                                                   
   "GST": ({"Atlantic/South_Georgia", "Asia/Bahrain", "Asia/Muscat",           
       "Asia/Qatar", "Asia/Dubai", "Pacific/Guam"}),                      
   "GYT": ({"America/Guyana"}),                                                
   "HADT": ({"America/Adak"}),                                                 
   "HART": ({"Asia/Harbin"}),                                                  
   "HAST": ({"America/Adak"}),                                                 
   "HAWT": ({"America/Adak"}),                                                 
   "HDT": ({"Pacific/Honolulu"}),                                              
   "HKST": ({"Asia/Hong_Kong"}),                                               
   "HKT": ({"Asia/Hong_Kong"}),                                                
   "HMT": ({"Atlantic/Azores", "Europe/Helsinki", "Asia/Dacca",                
       "Asia/Calcutta", "America/Havana"}),                               
   "HOVST": ({"Asia/Hovd"}),                                                   
   "HOVT": ({"Asia/Hovd"}),                                                    
   "HST": ({"Pacific/Johnston", "Pacific/Honolulu"}),                          
   "HWT": ({"Pacific/Honolulu"}),                                              
   "ICT": ({"Asia/Phnom_Penh", "Asia/Vientiane", "Asia/Bangkok",               
       "Asia/Saigon"}),                                                   
   "IDDT": ({"Asia/Jerusalem", "Asia/Gaza"}),                                  
   "IDT": ({"Asia/Jerusalem", "Asia/Gaza"}),                                   
   "IHST": ({"Asia/Colombo"}),                                                 
   "IMT": ({"Europe/Sofia", "Europe/Istanbul", "Asia/Irkutsk"}),               
   "IOT": ({"Indian/Chagos"}),                                                 
   "IRKMT": ({"Asia/Irkutsk"}),                                                
   "IRKST": ({"Asia/Irkutsk"}),                                                
   "IRKT": ({"Asia/Irkutsk"}),                                                 
   "IRST": ({"Asia/Tehran"}),                                                  
   "IRT": ({"Asia/Tehran"}),                                                   
   "ISST": ({"Atlantic/Reykjavik"}),                                           
   "IST": ({"Atlantic/Reykjavik", "Europe/Belfast", "Europe/Dublin",           
       "Asia/Dacca", "Asia/Thimbu", "Asia/Calcutta", "Asia/Jerusalem",    
       "Asia/Katmandu", "Asia/Karachi", "Asia/Gaza", "Asia/Colombo"}),    
   "JAYT": ({"Asia/Jayapura"}),                                                
   "JMT": ({"Atlantic/St_Helena", "Asia/Jerusalem"}),                          
   "JST": ({"Asia/Rangoon", "Asia/Dili", "Asia/Ujung_Pandang", "Asia/Tokyo",   
       "Asia/Kuala_Lumpur", "Asia/Kuching", "Asia/Manila",                
       "Asia/Singapore", "Pacific/Nauru"}),                               
   "KART": ({"Asia/Karachi"}),                                                 
   "KAST": ({"Asia/Kashgar"}),                                                 
   "KDT": ({"Asia/Seoul"}),                                                    
   "KGST": ({"Asia/Bishkek"}),                                                 
   "KGT": ({"Asia/Bishkek"}),                                                  
   "KMT": ({"Europe/Vilnius", "Europe/Kiev", "America/Cayman",                 
       "America/Jamaica", "America/St_Vincent", "America/Grand_Turk"}),   
   "KOST": ({"Pacific/Kosrae"}),                                               
   "KRAMT": ({"Asia/Krasnoyarsk"}),                                            
   "KRAST": ({"Asia/Krasnoyarsk"}),                                            
   "KRAT": ({"Asia/Krasnoyarsk"}),                                             
   "KST": ({"Asia/Seoul", "Asia/Pyongyang"}),                                  
   "KUYMT": ({"Europe/Samara"}),                                               
   "KUYST": ({"Europe/Samara"}),                                               
   "KUYT": ({"Europe/Samara"}),                                                
   "KWAT": ({"Pacific/Kwajalein"}),                                            
   "LHST": ({"Australia/Lord_Howe"}),                                          
   "LINT": ({"Pacific/Kiritimati"}),                                           
   "LKT": ({"Asia/Colombo"}),                                                  
   "LPMT": ({"America/La_Paz"}),                                               
   "LRT": ({"Africa/Monrovia"}),                                               
   "LST": ({"Europe/Riga"}),                                                   
   "M": ({"Europe/Moscow"}),                                                   
   "MADST": ({"Atlantic/Madeira"}),                                            
   "MAGMT": ({"Asia/Magadan"}),                                                
   "MAGST": ({"Asia/Magadan"}),                                                
   "MAGT": ({"Asia/Magadan"}),                                                 
   "MALT": ({"Asia/Kuala_Lumpur", "Asia/Singapore"}),                          
   "MART": ({"Pacific/Marquesas"}),                                            
   "MAWT": ({"Antarctica/Mawson"}),                                            
   "MDDT": ({"America/Cambridge_Bay", "America/Yellowknife",                   
       "America/Inuvik"}),                                               
   "MDST": ({"Europe/Moscow"}),                                                
   "MDT": ({"America/Denver", "America/Phoenix", "America/Boise",              
       "America/Regina", "America/Swift_Current", "America/Edmonton",     
       "America/Cambridge_Bay", "America/Yellowknife", "America/Inuvik",  
       "America/Chihuahua", "America/Hermosillo", "America/Mazatlan"}),   
   "MHT": ({"Pacific/Majuro", "Pacific/Kwajalein"}),                           
   "MMT": ({"Indian/Maldives", "Europe/Minsk", "Europe/Moscow", "Asia/Rangoon",
       "Asia/Ujung_Pandang", "Asia/Colombo", "Pacific/Easter",            
       "Africa/Monrovia", "America/Managua", "America/Montevideo"}),      
   "MOST": ({"Asia/Macao"}),                                                   
   "MOT": ({"Asia/Macao"}),                                                    
   "MPT": ({"Pacific/Saipan"}),                                                
   "MSK": ({"Europe/Minsk", "Europe/Tallinn", "Europe/Riga", "Europe/Vilnius", 
       "Europe/Chisinau", "Europe/Kiev", "Europe/Uzhgorod",               
       "Europe/Zaporozhye", "Europe/Simferopol"}),                        
   "MST": ({"Europe/Moscow", "America/Denver", "America/Phoenix",              
       "America/Boise", "America/Regina", "America/Swift_Current",        
       "America/Edmonton", "America/Dawson_Creek",                        
       "America/Cambridge_Bay", "America/Yellowknife", "America/Inuvik",  
       "America/Mexico_City", "America/Chihuahua", "America/Hermosillo",  
       "America/Mazatlan", "America/Tijuana"}),                           
   "MUT": ({"Indian/Mauritius"}),                                              
   "MVT": ({"Indian/Maldives"}),                                               
   "MWT": ({"America/Denver", "America/Phoenix", "America/Boise"}),            
   "MYT": ({"Asia/Kuala_Lumpur", "Asia/Kuching"}),                             
   "NCST": ({"Pacific/Noumea"}),                                               
   "NCT": ({"Pacific/Noumea"}),                                                
   "NDT": ({"America/Nome", "America/Adak", "America/St_Johns",                
       "America/Goose_Bay"}),                                             
   "NEGT": ({"America/Paramaribo"}),                                           
   "NFT": ({"Pacific/Norfolk"}),                                               
   "NMT": ({"Pacific/Norfolk"}),                                               
   "NOVMT": ({"Asia/Novosibirsk"}),                                            
   "NOVST": ({"Asia/Novosibirsk"}),                                            
   "NOVT": ({"Asia/Novosibirsk"}),                                             
   "NPT": ({"Asia/Katmandu"}),                                                 
   "NRT": ({"Pacific/Nauru"}),                                                 
   "NST": ({"Europe/Amsterdam", "Pacific/Pago_Pago", "Pacific/Midway",         
       "America/Nome", "America/Adak", "America/St_Johns",                
       "America/Goose_Bay"}),                                             
   "NUT": ({"Pacific/Niue"}),                                                  
   "NWT": ({"America/Nome", "America/Adak"}),                                  
   "NZDT": ({"Antarctica/McMurdo"}),                                           
   "NZHDT": ({"Pacific/Auckland"}),                                            
   "NZST": ({"Antarctica/McMurdo", "Pacific/Auckland"}),                       
   "OMSMT": ({"Asia/Omsk"}),                                                   
   "OMSST": ({"Asia/Omsk"}),                                                   
   "OMST": ({"Asia/Omsk"}),                                                    
   "PDDT": ({"America/Inuvik", "America/Whitehorse", "America/Dawson"}),       
   "PDT": ({"America/Los_Angeles", "America/Juneau", "America/Boise",          
       "America/Vancouver", "America/Dawson_Creek", "America/Inuvik",     
       "America/Whitehorse", "America/Dawson", "America/Tijuana"}),       
   "PEST": ({"America/Lima"}),                                                 
   "PET": ({"America/Lima"}),                                                  
   "PETMT": ({"Asia/Kamchatka"}),                                              
   "PETST": ({"Asia/Kamchatka"}),                                              
   "PETT": ({"Asia/Kamchatka"}),                                               
   "PGT": ({"Pacific/Port_Moresby"}),                                          
   "PHOT": ({"Pacific/Enderbury"}),                                            
   "PHST": ({"Asia/Manila"}),                                                  
   "PHT": ({"Asia/Manila"}),                                                   
   "PKT": ({"Asia/Karachi"}),                                                  
   "PMDT": ({"America/Miquelon"}),                                             
   "PMMT": ({"Pacific/Port_Moresby"}),                                         
   "PMST": ({"America/Miquelon"}),                                             
   "PMT": ({"Antarctica/DumontDUrville", "Europe/Prague", "Europe/Paris",      
       "Europe/Monaco", "Africa/Algiers", "Africa/Tunis",                 
       "America/Panama", "America/Paramaribo"}),                          
   "PNT": ({"Pacific/Pitcairn"}),                                              
   "PONT": ({"Pacific/Ponape"}),                                               
   "PPMT": ({"America/Port-au-Prince"}),                                       
   "PST": ({"Pacific/Pitcairn", "America/Los_Angeles", "America/Juneau",       
       "America/Boise", "America/Vancouver", "America/Dawson_Creek",      
       "America/Inuvik", "America/Whitehorse", "America/Dawson",          
       "America/Hermosillo", "America/Mazatlan", "America/Tijuana"}),     
   "PWT": ({"Pacific/Palau", "America/Los_Angeles", "America/Juneau",          
       "America/Boise", "America/Tijuana"}),                              
   "PYST": ({"America/Asuncion"}),                                             
   "PYT": ({"America/Asuncion"}),                                              
   "QMT": ({"America/Guayaquil"}),                                             
   "RET": ({"Indian/Reunion"}),                                                
   "RMT": ({"Atlantic/Reykjavik", "Europe/Rome", "Europe/Riga",                
       "Asia/Rangoon"}),                                                  
   "S": ({"Europe/Moscow"}),                                                   
   "SAMMT": ({"Europe/Samara"}),                                               
   "SAMST": ({"Europe/Samara", "Asia/Samarkand"}),                             
   "SAMT": ({"Europe/Samara", "Asia/Samarkand", "Pacific/Pago_Pago",           
       "Pacific/Apia"}),                                                 
   "SAST": ({"Africa/Maseru", "Africa/Windhoek", "Africa/Johannesburg",        
       "Africa/Mbabane"}),                                               
   "SBT": ({"Pacific/Guadalcanal"}),                                           
   "SCT": ({"Indian/Mahe"}),                                                   
   "SDMT": ({"America/Santo_Domingo"}),                                        
   "SGT": ({"Asia/Singapore"}),                                                
   "SHEST": ({"Asia/Aqtau"}),                                                  
   "SHET": ({"Asia/Aqtau"}),                                                   
   "SJMT": ({"America/Costa_Rica"}),                                           
   "SLST": ({"Africa/Freetown"}),                                              
   "SMT": ({"Atlantic/Stanley", "Europe/Stockholm", "Europe/Simferopol",       
       "Asia/Phnom_Penh", "Asia/Vientiane", "Asia/Kuala_Lumpur",          
       "Asia/Singapore", "Asia/Saigon", "America/Santiago"}),             
   "SRT": ({"America/Paramaribo"}),                                            
   "SST": ({"Pacific/Pago_Pago", "Pacific/Midway"}),                           
   "SVEMT": ({"Asia/Yekaterinburg"}),                                          
   "SVEST": ({"Asia/Yekaterinburg"}),                                          
   "SVET": ({"Asia/Yekaterinburg"}),                                           
   "SWAT": ({"Africa/Windhoek"}),                                              
   "SYOT": ({"Antarctica/Syowa"}),                                             
   "TAHT": ({"Pacific/Tahiti"}),                                               
   "TASST": ({"Asia/Samarkand", "Asia/Tashkent"}),                             
   "TAST": ({"Asia/Samarkand", "Asia/Tashkent"}),                              
   "TBIST": ({"Asia/Tbilisi"}),                                                
   "TBIT": ({"Asia/Tbilisi"}),                                                 
   "TBMT": ({"Asia/Tbilisi"}),                                                 
   "TFT": ({"Indian/Kerguelen"}),                                              
   "TJT": ({"Asia/Dushanbe"}),                                                 
   "TKT": ({"Pacific/Fakaofo"}),                                               
   "TMST": ({"Asia/Ashkhabad"}),                                               
   "TMT": ({"Europe/Tallinn", "Asia/Tehran", "Asia/Ashkhabad"}),               
   "TOST": ({"Pacific/Tongatapu"}),                                            
   "TOT": ({"Pacific/Tongatapu"}),                                             
   "TPT": ({"Asia/Dili"}),                                                     
   "TRST": ({"Europe/Istanbul"}),                                              
   "TRT": ({"Europe/Istanbul"}),                                               
   "TRUT": ({"Pacific/Truk"}),                                                 
   "TVT": ({"Pacific/Funafuti"}),                                              
   "ULAST": ({"Asia/Ulaanbaatar"}),                                            
   "ULAT": ({"Asia/Ulaanbaatar"}),                                             
   "URUT": ({"Asia/Urumqi"}),                                                  
   "UYHST": ({"America/Montevideo"}),                                          
   "UYT": ({"America/Montevideo"}),                                            
   "UZST": ({"Asia/Samarkand", "Asia/Tashkent"}),                              
   "UZT": ({"Asia/Samarkand", "Asia/Tashkent"}),                               
   "VET": ({"America/Caracas"}),                                               
   "VLAMT": ({"Asia/Vladivostok"}),                                            
   "VLAST": ({"Asia/Vladivostok"}),                                            
   "VLAT": ({"Asia/Vladivostok"}),                                             
   "VUST": ({"Pacific/Efate"}),                                                
   "VUT": ({"Pacific/Efate"}),                                                 
   "WAKT": ({"Pacific/Wake"}),                                                 
   "WARST": ({"America/Jujuy", "America/Mendoza"}),                            
   "WART": ({"America/Jujuy", "America/Mendoza"}),                             
   "WAST": ({"Africa/Ndjamena", "Africa/Windhoek"}),                           
   "WAT": ({"Africa/Luanda", "Africa/Porto-Novo", "Africa/Douala",             
       "Africa/Bangui", "Africa/Ndjamena", "Africa/Kinshasa",             
       "Africa/Brazzaville", "Africa/Malabo", "Africa/Libreville",        
       "Africa/Banjul", "Africa/Conakry", "Africa/Bissau",                
       "Africa/Bamako", "Africa/Nouakchott", "Africa/El_Aaiun",           
       "Africa/Windhoek", "Africa/Niamey", "Africa/Lagos", "Africa/Dakar",
       "Africa/Freetown"}),                                               
   "WEST": ({"Atlantic/Faeroe", "Atlantic/Azores", "Atlantic/Madeira",         
       "Atlantic/Canary", "Europe/Brussels", "Europe/Luxembourg",        
       "Europe/Monaco", "Europe/Lisbon", "Europe/Madrid",                
       "Africa/Algiers", "Africa/Casablanca", "Africa/Ceuta"}),          
   "WET": ({"Atlantic/Faeroe", "Atlantic/Azores", "Atlantic/Madeira",          
       "Atlantic/Canary", "Europe/Andorra", "Europe/Brussels",            
       "Europe/Luxembourg", "Europe/Monaco", "Europe/Lisbon",             
       "Europe/Madrid", "Africa/Algiers", "Africa/Casablanca",            
       "Africa/El_Aaiun", "Africa/Ceuta"}),                               
   "WFT": ({"Pacific/Wallis"}),                                                
   "WGST": ({"America/Godthab"}),                                              
   "WGT": ({"America/Godthab"}),                                               
   "WMT": ({"Europe/Vilnius", "Europe/Warsaw"}),                               
   "WST": ({"Antarctica/Casey", "Pacific/Apia", "Australia/Perth"}),           
   "YAKMT": ({"Asia/Yakutsk"}),                                                
   "YAKST": ({"Asia/Yakutsk"}),                                                
   "YAKT": ({"Asia/Yakutsk"}),                                                 
   "YAPT": ({"Pacific/Yap"}),                                                  
   "YDDT": ({"America/Whitehorse", "America/Dawson"}),                         
   "YDT": ({"America/Yakutat", "America/Whitehorse", "America/Dawson"}),       
   "YEKMT": ({"Asia/Yekaterinburg"}),                                          
   "YEKST": ({"Asia/Yekaterinburg"}),                                          
   "YEKT": ({"Asia/Yekaterinburg"}),                                           
   "YERST": ({"Asia/Yerevan"}),                                                
   "YERT": ({"Asia/Yerevan"}),                                                 
   "YST": ({"America/Yakutat", "America/Whitehorse", "America/Dawson"}),       
   "YWT": ({"America/Yakutat"}),                                               
   "___": ({"Antarctica/Casey", "Antarctica/Davis", "Antarctica/Mawson",       
       "Antarctica/DumontDUrville", "Antarctica/Syowa",                   
       "Antarctica/Palmer", "Antarctica/McMurdo", "Indian/Kerguelen"}),   
]);
